import es
import playerlib
import gungamelib
import gamethread
import usermsg

# ==============================================================================
#   ADDON REGISTRATION
# ==============================================================================
# Register this addon with EventScripts
info = es.AddonInfo()
info.name     = 'warorphans.net KAGK'
info.version  = '1.0'
info.url      = 'http://www.warorphans.net/forums/'
info.basename = 'gungame/custom_addons/gg_kagk'
info.author   = 'snahproraw'

# ==============================================================================
#   GAME EVENTS
# ==============================================================================

dict_players = {}
good_weapons = ['hegrenade','knife']
allguns = ['glock','usp','p228','deagle','fiveseven','elite','m3','xm1014','tmp','mac10','mp5navy','ump45','p90','galil','famas','ak47','scout','m4a1','sg550','g3sg1','awp','sg552','aug','m249']
primary_weapons = ['m3','xm1014','tmp','mac10','mp5navy','ump45','p90','galil','famas','ak47','scout','m4a1','sg550','g3sg1','awp','sg552','aug','m249']
extras = ['hegrenade','flashbang','smokegrenade','knife','c4','world','0']

def load():
    addon = gungamelib.registerAddon('gg_kagk')
    addon.setDisplayName('gg_kagk')
    for userid in es.getUseridList():
        dict_players[userid] = {'extrafiring':0}

def unload():
    gungamelib.unregisterAddon('gg_kagk')

def player_spawn(ev):
    userid = int(ev['userid'])
    dict_players[userid] = {'extrafiring':0}
    gamethread.delayed(0.3, checkWeapons, userid)

def checkWeapons(userid):
    ggplayer = gungamelib.getPlayer(userid)
    the_weapon = ggplayer.getWeapon()
    if not the_weapon in ['hegrenade', 'knife']:
        wepstring = 'weapon_%s' % the_weapon
        player = playerlib.getPlayer(userid)
        if not player.attributes['weapon'] in ['weapon_knife', wepstring]:
            if not gungamelib.getGlobal('isWarmUp'):
                if not player.attributes['isdead']:
                    ggplayer.stripPlayer()
                    ggplayer.giveWeapon()
                    gamethread.delayed(0.05, es.sexec, (userid, 'use %s' % wepstring))

def player_disconnect(ev):
    userid = int(ev['userid'])
    if dict_players.has_key(userid):
        del dict_players[userid]

def gg_levelup(ev):
    attacker = int(ev['attacker'])
    ggplayer = gungamelib.getPlayer(attacker)
    if not ggplayer.getWeapon() in ['hegrenade','knife']:
        es.sexec(attacker, "use weapon_knife")
        dict_players[attacker]['extrafiring'] = 1
        gamethread.delayed(0.4, resetExtraFiring, (attacker))
        if es.getplayersteamid(attacker) == 'BOT':
            es.server.queuecmd('est_dropweapon %s 1' % attacker)
            es.server.queuecmd('est_dropweapon %s 2' % attacker)

def item_pickup(ev):
    item = ev['item']
    userid = int(ev['userid'])
    if not gungamelib.getGlobal('isWarmUp'):
        if not item in extras:
            ggplayer = gungamelib.getPlayer(userid)
            the_weapon = ggplayer.getWeapon()
            if item != the_weapon:
                if es.getplayersteamid(userid) == 'BOT':
                    if not the_weapon in good_weapons:
                        if item in primary_weapons:
                            es.server.queuecmd('est_dropweapon %s 1' % userid)
                        else:
                            es.server.queuecmd('est_dropweapon %s 2' % userid)
    player = playerlib.getPlayer(userid)
    if item in primary_weapons:
        if not player.get('ammo', 'primary'):
            player.set('ammo', ['primary', '80'])
    else:
        if not player.get('ammo', 'secondary'):
            player.set('ammo', ['secondary', '50'])

def resetExtraFiring(userid):
    dict_players[userid]['extrafiring'] = 0

def player_hurt(ev):
    attacker = int(ev['attacker'])
    userid   = int(ev['userid'])
    ggvictim = gungamelib.getPlayer(userid)
    if not ggvictim.isPlayerAFK():
        if ev['weapon'] in allguns:
            if not gungamelib.getGlobal('isWarmUp'):
                    if ev['es_attackerteam'] != ev['es_userteam']:
                        if not ev['weapon'] in extras:
                            ggplayer = gungamelib.getPlayer(attacker)
                            the_weapon = ggplayer.getWeapon()
                            if ev['weapon'] != the_weapon:
                                if not the_weapon in good_weapons:
                                    if not dict_players[attacker]['extrafiring']:
                                        victim = playerlib.getPlayer(userid)
                                        if not victim.attributes['isdead']:
                                            health = int(ev['health']) + int(ev['dmg_health'])
                                            victim.set('health', health)
                                            armor = int(ev['armor']) + int(ev['dmg_armor'])
                                            victim.set('armor', armor)
                                            es.server.queuecmd('ma_slap %d 20' % int(ev['attacker']))
                                            es.sexec(attacker, "use weapon_knife")
                                            ggplayer = gungamelib.getPlayer(attacker)
                                            the_weapon = ggplayer.getWeapon()
                                            the_level = ggplayer['level']
                                            es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#lightgreen %s #defaultis fighting with a#lightgreen %s #defaultwhile on level#green %d#lightgreen %s' % (ev['es_attackername'], ev['weapon'], the_level, the_weapon))
                                            es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#lightgreen %s #defaultneeds to type #greenRULES#default and obey them!!' % ev['es_attackername'])
                                            es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#lightgreen %s #defaultneeds to type #greenRULES#default and obey them!!' % ev['es_attackername'])
                                            es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#default Type #greenRULES #defaultplease if you are new to the server and obey them!!')
                                            gamethread.delayed(0.5, es.server.queuecmd, ('ma_chat Make sure %s knows not to wound with incorrect guns' % ev['es_attackername']))
                                            gamethread.delayed(0.5, es.server.queuecmd, ('ma_chat Make sure %s knows not to wound with incorrect guns' % ev['es_attackername']))
                                        else:
                                            if userid != attacker:
                                                es.sexec(attacker, "kill")
                                                es.sexec(attacker, "spectate")
                                                gamethread.delayed(1, usermsg.motd, (attacker, 2, "Server Rules", "www.warorphans.net/servers/gungame/motd.html"))
                                                ggplayer = gungamelib.getPlayer(attacker)
                                                the_weapon = ggplayer.getWeapon()
                                                the_level = ggplayer['level']
                                                es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#lightgreen %s #defaultgot a kill with a#lightgreen %s #defaultwhile on level#green %d#lightgreen %s' % (ev['es_attackername'], ev['weapon'], the_level, the_weapon))
                                                es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#lightgreen %s #defaultneeds to type #greenRULES#default and obey them!!' % ev['es_attackername'])
                                                es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#lightgreen %s #defaultneeds to type #greenRULES#default and obey them!!' % ev['es_attackername'])
                                                es.msg('#multi','#green[#lightgreenKnife#green-#lightgreenMod#green]#default Type #greenRULES #defaultplease if you are new to the server and obey them!!')
                                                gamethread.delayed(0.5, es.server.queuecmd, ('ma_chat Make sure %s knows not to kill with incorrect guns' % ev['es_attackername']))
                                                gamethread.delayed(0.5, es.server.queuecmd, ('ma_chat Make sure %s knows not to kill with incorrect guns' % ev['es_attackername']))